{*******************************************************}
{                                                       }
{  VG Library II                                        }
{                                                       }
{  Demo Application                                     }
{                                                       }
{  (c) 1997, 2000 by Vladimir Gaitanoff                 }
{                                                       }
{*******************************************************}

{$I vg2.inc}

unit fmChild;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  vg2PropStore;

type
  TChildForm = class(TForm)
    psStore: Tvg2PropStorage;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  TChildFormClass = class of TChildForm;

procedure ShowForm(FormClass: TChildFormClass);

implementation

uses dmMain, Buttons, vg2SysUtils;

{$R *.DFM}

procedure ShowForm(FormClass: TChildFormClass);

  function FindForm: TForm;
  var
    I: Integer;
  begin
    for I := 0 to Screen.FormCount - 1 do
    begin
      Result := Screen.Forms[I];
      if Result is FormClass then Exit;
    end;
    Result := nil;
  end;

var
  Form: TForm;
begin
  Form := FindForm;
  if not Assigned(Form) then
    Form := FormClass.Create(Application.MainForm);
  Form.BringToFront;
end;

procedure TChildForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TChildForm.FormCreate(Sender: TObject);

  procedure LoadGlyph(Instance: TComponent; Data: Pointer);
  var
    Button: TSpeedButton absolute Instance;
    CompName: string;
  begin
    if Instance.Tag = 13 then{ Magic number }
    begin
      CompName := Copy(Button.Name, 3, MaxInt);
      Button.Glyph.Handle := LoadBitmap(HInstance, PChar(CompName));
      Button.Hint := CompName;
      Button.ShowHint := True;
    end;
  end;

begin
   ForEachComponent(Self, TSpeedButton, @LoadGlyph, nil, True);
end;

end.
