{*******************************************************}
{                                                       }
{  VG Library II                                        }
{                                                       }
{  VCL Design Editors (BDE)                             }
{                                                       }
{  (c) 1997, 2001 by Vladimir Gaitanoff                 }
{                                                       }
{*******************************************************}

{$I vg2.inc}
{$D-,L-}

unit vg2BDEDsgn;

interface
uses Classes, DsgnIntf, vg2DBDsgn;

type
{ TSessionNameProperty }

  TSessionNameProperty = class(TDBStringProperty)
  public
    procedure GetValueList(List: TStrings); override;
  end;

{ TDatabaseNameProperty }

  TDatabaseNameProperty = class(TDBStringProperty)
  public
    procedure GetValueList(List: TStrings); override;
  end;

implementation
uses TypInfo, DBTables;

{ TSessionNameProperty }
procedure TSessionNameProperty.GetValueList(List: TStrings);
begin
  Sessions.GetSessionNames(List);
end;

{ TDatabaseNameProperty }
procedure TDatabaseNameProperty.GetValueList(List: TStrings);
var
  S: string;
  P: PPropInfo;
begin
  if GetComponent(0) is TDBDataSet then
    TDBDataSet(GetComponent(0)).DBSession.GetDatabaseNames(List)
  else begin
    P := TypInfo.GetPropInfo(GetComponent(0).ClassInfo, 'SessionName');
    if Assigned(P) then
    begin
      S := GetStrProp(GetComponent(0), P);
      Sessions.FindSession(S).GetDatabaseNames(List)
    end;
  end;
end;

end.
